#!/usr/bin/php
<?php

function main()
{

	$hostname = $_SERVER;
	$opt_host = $hostname['argv'][1];
	if (!$opt_host){
		print "Favor Informar o nome do Host.\n";
		exit(3);
	}
	$consulta_ic = getHostInfo($opt_host);

	#print_r($consulta_ic);

	if ($consulta_ic['clusters']){
		$clusters = $consulta_ic['clusters'];
		$clusters = explode("|",$clusters);
		#print_r($clusters);
		$c = 0;
		foreach ($clusters as $cluster){
				#print $cluster . "\n";
				$cluster = preg_match('/Cluster:(?P<cluster>\d+),members:(?P<members>\d+)\((?P<hosts>\S+)\),Expression:cluster(?P<expression>\S+)(?P<valueexpr>\d+)]/',$cluster,$cluster_i);
				#print_r($cluster_i);
				#print $cluster_i['hosts'] . "\n";
				$cluster_member = $cluster_i['members'];
				$cluster_number = $cluster_i['cluster'];
				$host_states = getAvailIC($cluster_i['hosts']);
				#print $host_states . "\n";
				$host_status = rtrim($host_states,',');
				$count_hosts = explode(",",$host_status);
				$tags = count($count_hosts);
				if ($host_status){
						$host_affected .= "<b>Cluster[$cluster_number]</b> ICS: $host_status | ";
				} 
		}
		#print $tags . "\n";
		$cluster_affected = rtrim($host_affected,'| ');
        $available = ($cluster_member - $tags);

			#print $available . "\n";


            if ($available >= $cluster_i['valueexpr']){
				$cluster_affected=NULL;
            }else{
				  $cluster_affected;
            }
	}
	if ($consulta_ic['spfnodes']){
        $spfnodes = $consulta_ic['spfnodes'];
        #print $spfnodes . "\n";
		#[spfNodes:2,hosts(778)]
		preg_match('/pfNodes:(?P<spfNodes>\d+),hosts\((?P<hosts>\S+)\)]/',$spfnodes,$spf_nodes);
		#print_r($spf_nodes);
		#print $spf_nodes['hosts']  . "\n";
		$spfnodes_states = getAvailIC($spf_nodes['hosts']);
		#print_r($spfnodes_states);
	    $spfnodes_status = rtrim($spfnodes_states,',');
		$spfnodes_status = "ICs: $spfnodes_status";

    }

	if ($cluster_affected and $spfnodes_states){
		print "$cluster_affected / $spfnodes_status\n";
		exit(2);
	}elseif($cluster_affected){
		print "$cluster_affected\n";
		exit(2);
	}elseif($spfnodes_states){
		print "$spfnodes_status\n";
		exit(2);
	}else{
		print "Servico em funcionamento normal!\n";
		exit(0);
	}


}

main();


function getPriaxProperties($responseArray)
{

$spfNodes = $responseArray['soapBody']['ns2getOpmonBeingDependencyListResponse']['DependencyList']['spfNodes'];
$clusters = $responseArray['soapBody']['ns2getOpmonBeingDependencyListResponse']['DependencyList']['clusters'];



if ($clusters){


	if ($clusters['members']){

		foreach ($clusters as $cluster => $value){


			$cluster_number = $cluster;
			$members_id = NULL;
			$members_count = count($clusters['members']);

			#print $members_count . "\n";

				foreach ($clusters['members'] as $member){

		    

					#$cluster_members = "members:$members_count";


					#print_r($member);


					foreach ($member['attributes']['entry'] as $key => $value){


						if ($key == 'value' and is_string($value) ){
							$members_id .= "$value,";
						}
					}
			}
			$expression = $clusters['upExpression'];
			$members_id = rtrim($members_id,',');


			if (!$members_id){
				continue;
			}else{
				$members_count = $members_count - 1;
				#print $members_count . "Memeber \n";
				$cluster_members = "members:$members_count";
				$clusters_infos = "[Cluster:0,$cluster_members($members_id),Expression:$expression]";
			}
		}				
	}else{
		
		foreach ($clusters as $cluster => $value){


            $cluster_number = $cluster;
            $members_id = NULL;

                foreach ($clusters[$cluster]['members'] as $member){


                    $members_count = count($clusters[$cluster]['members']);

                    $cluster_members = "members:$members_count";


                    #print_r($member);


                    foreach ($member['attributes']['entry'] as $key => $value){


                        if ($key == 'value' and is_string($value) ){
                            $members_id .= "$value,";
                        }
                    }
            }
            $expression = $clusters[$cluster]['upExpression'];
            $members_id = rtrim($members_id,',');
            print $members_id . "\n";
            if (!$members_id){
                continue;
            }else{
                $clusters_infos .= "[Cluster:$cluster_number,$cluster_members($members_id),Expression:$expression]|";
            }
        }
    }
$clusters_infos = rtrim($clusters_infos,'|');
#print $clusters_infos . "\n";

}

if ($spfNodes){
$members_count = count($spfNodes);

	foreach ($spfNodes as $member){
		foreach ($member['attributes']['entry'] as $key => $value){
			if ($key == 'value' and is_string($value)){
				$host_id .= "$value,";
			}
		}
	}

	$hosts = rtrim($host_id,',');
	$spfNodes_info = "[spfNodes:$members_count,hosts($hosts)]";
	#print $spfNodes_info . "\n";
}


return array('Cluster'=>"$clusters_infos",'SPFNodes'=>"$spfNodes_info");


}

function logRequestError($soaph)
{
    $error = sprintf(
        "[%s]\nrequest header:\n%s\nrequest:\n%s\nresponse header:\n%s\nresponse:\n%s\n",
        time(),
        $soaph->__getLastRequestHeaders(),
        $soaph->__getLastRequest(),
        $soaph->__getLastResponseHeaders(),
        $soaph->__getLastResponse()

    );

    $fp = @fopen("/tmp/soap-catalogo-errors.log", "a");
    fprintf($fp, "%s\n", $error);
    fclose($fp);
}




function getPriaxUrl(){

		$configFile = fopen("/usr/local/opmon/share/priax/sync/config-inc.php", "r") or die("Unable to open config-inc.php file!");

        while(!feof($configFile)) {
            $url = fgets($configFile);
            if (preg_match('/^define\("PRIAXURL","(?P<url>\S+)"/',$url,$tag)){
                    $urlPriax = $tag['url'];
            }

        }
		fclose($configFile);

	return $urlPriax;
}


function getSoapHandler()
{
    $stream_context = stream_context_create(
        array(
            'http' => array(
                'protocol_version'  => 1.0
            )
        )
    );


	$url = getPriaxUrl();

    #$url = "http://priaxws.interop.com.br/interop/PriaxServices?WSDL";

	#print $url . "\n";

    $client = new SoapClient(
        $url,
        array(
            "stream_context" => $stream_context,
            "trace" => 1,
			"cache_wsdl" => WSDL_CACHE_NONE
        )
    );

    return $client;
}


function getCatalogosFromPriax($host_id)
{
    $data = false;
    
	$soaph = getSoapHandler();
    try {

		$data = $soaph->__soapCall("getOpmonBeingDependencyList",
             array(
                "getOpmonBeingDependencyList" => array(
                    "beingDependency" => array(
                        "beingId" => $host_id,
                        "returnAttribs" => array(
                            "attributes" => array(
                                "entry" => array(
                                    "key" => 'OpMon\OpMonID'
                                )
                            )
                        )
                     )
                )
            )
        );

    } catch (Exception $e) {
        logRequestError($soaph);
    }

	$data = $soaph->__getLastResponse();
    return $data;
}

function getAvailIC($value)
{
	$host_id = $value;
	$servername = "localhost";
	$username = "root";
	$password = "";
	$dbname = "opmon4";

	$conn = new mysqli($servername, $username, $password, $dbname);
	if ($conn->connect_error) {
		die("Connection failed: " . $conn->connect_error);
	}

	$sql = "select host_name from host_status where host_id IN ($host_id) and state_type = 1 and current_state <> 0";

	$result = $conn->query($sql) or die ("Error in query: $sql. ".mysql_error());;


	while ($row = $result->fetch_assoc()) {
		$hosts_state = $row['host_name'];
		$host_name .= "($hosts_state),";
		
    }

	$conn->close();

return $host_name;

}


function getHostInfo($opt_host)
{

    $servername = "localhost";
    $username = "root";
    $password = "";
    $dbname = "opmon4";

    $conn = new mysqli($servername, $username, $password, $dbname);
    if ($conn->connect_error) {
        die("Connection failed: " . $conn->connect_error);
    }

    $sql = "select opcfg.nagios_hosts.host_id from opcfg.nagios_hosts where opcfg.nagios_hosts.host_name = '$opt_host'";

    $result = $conn->query($sql);

    $row = $result->fetch_assoc();

    $host_id = $row['host_id'];

	if (!$host_id){
			print "Host ID nao encontrado!\n";
			exit(2);
	}

	#print $host_id . "\n";

	$sql_consulta = "select * from priax.services_conf where host_id = '$host_id'";

    $result_consulta = $conn->query($sql_consulta);
    $row_consulta = $result_consulta->fetch_assoc();
    
    #print_r($row_consulta);
   
    if (!$row_consulta){
			$myXMLData = getCatalogosFromPriax($host_id);
			$xml = $myXMLData;
			$xml = preg_replace("/(<\/?)(\w+):([^>]*>)/", '$1$2$3', $xml);
			$xml = simplexml_load_string($xml);
			$json = json_encode($xml);
			$responseArray = json_decode($json, true);
			$properties = getPriaxProperties($responseArray);
			#print_r($properties);
			if (is_soap_fault($properties)) {
				trigger_error("SOAP Fault: (faultcode: {$properties->faultcode}, faultstring: {$properties->faultstring})", E_USER_ERROR);
			}
			if (!$properties['Cluster']){
				$clusters_infos = NULL;
			}else{
				$clusters_infos = $properties['Cluster'];
			}
			if (!$properties['SPFNodes']){
				$spfNodes_info = NULL;
			}else{
				$spfNodes_info = $properties['SPFNodes'];
			}
			$sql_insert = "INSERT INTO priax.services_conf (host_id,host_name,clusters,spfnodes,created) VALUES ( '$host_id','$opt_host','$clusters_infos','$spfNodes_info',CURRENT_TIMESTAMP())";
			$result_insert = $conn->query($sql_insert);
			#print_r($result_insert);
			$sql_consulta = "select * from priax.services_conf where host_id = '$host_id'";
			$result_consulta = $conn->query($sql_consulta);
			$row_consulta = $result_consulta->fetch_assoc();


    }
	$time = strtotime($row_consulta['created']);
    $timestamp = time();
    $timediff = ($timestamp - $time);

    #print $host_id . "\n";
    #print $timestamp . "\n";
	#print $timediff . "\n";

	if ($timediff > '1800'){
		#print "AQUI\n";
		$myXMLData = getCatalogosFromPriax($host_id);
        $xml = $myXMLData;
        $xml = preg_replace("/(<\/?)(\w+):([^>]*>)/", '$1$2$3', $xml);
        $xml = simplexml_load_string($xml);
        $json = json_encode($xml);
		#print_r($json);
        $responseArray = json_decode($json, true);
		#print_r($responseArray);
        $properties = getPriaxProperties($responseArray);
        #print_r($properties);
        if (!$properties['Cluster']){
            $clusters_infos = NULL;
        }else{
            $clusters_infos = $properties['Cluster'];
        }
        if (!$properties['SPFNodes']){
            $spfNodes_info = NULL;
        }else{
            $spfNodes_info = $properties['SPFNodes'];
        }
		$sql_update = "UPDATE priax.services_conf set host_name = '$opt_host' , clusters = '$clusters_infos' , spfnodes = '$spfNodes_info' , created = CURRENT_TIMESTAMP() where host_id = $host_id";
		$result_update = $conn->query($sql_update);
		#print_r($result_update);
		$sql_consulta = "select * from priax.services_conf where host_id = '$host_id'";
		$result_consulta = $conn->query($sql_consulta);
		$row_consulta = $result_consulta->fetch_assoc();
	}
		
	if (!$row_consulta){
        print "Nao existem informacoes para o ID do Servico!\n";
        exit(1);
    }

	$conn->close();

	return $row_consulta;
}

?>
