#!/usr/bin/php
<?php
include("/usr/local/opmon/etc/config.php");
set_logged_user('opmonadmin');

$query = "select * from export_log";
$result = do_query( $query, DBOPCFG );

$error_found = false;
$date_last_export = "";

if (isset($result->fields['entry_time'])) {
	$date_last_export = $result->fields['entry_time'];
}

if (isset($result->fields['data'])) {
	$export_date = json_decode($result->fields['data']);
	foreach ($export_date as $export) {
		if ($export->status == "error") {
			$error_found = true;
		}
	}
	$result->Close();
}

if ($error_found === true) {
	print "OpMon configuration has errors, please check Configuration / Export for details - Last export/apply on $date_last_export\n";
	exit(2);
}
print "OpMon configuration if OK - Last export/apply on $date_last_export\n";
exit(0);
